import pygame, math, sys, os, pyganim, shelve, time

WIDTH = 640
HEIGHT = 640
DISPLAY = (WIDTH, HEIGHT)
DEPTH = 32
FLAGS = 0

# colour of the background

bgcolour = (0,0,255)

# size of each tile, for level drawing (x,y)
tile_size = (32,32)
# size of the player (x,y)
player_size = (64,64)
# maximum FPS
maxfps = 60

pygame.mixer.init()
chipget = pygame.mixer.Sound('assets/sound/chipget.wav') # The sound when you get a chip
gateopen = pygame.mixer.Sound('assets/sound/gateopen.wav') # The sound when you open a gate
music = pygame.mixer.Sound('assets/sound/Untitled 12.wav') # The background music


    
def main():
    music.play(-1)
    if len(sys.argv) == 1:
        level_queue = ['level1.csv','level2.csv','level3.csv','level4.csv',\
                       'level5.csv']
    else:
        level_queue = sys.argv[1:]
    for current_level in level_queue:
        messages_path=current_level[:-4]+'_messages.txt'
        if os.path.isfile(messages_path):
            current_level_messages = parse_msg(messages_path)
        else:
            current_level_messages = []
        start_level(current_level, current_level_messages)
    print "You have beaten the game!"


def parse_msg(msg_path):
    f = open(msg_path)
    messages = f.read()
    message_list = messages.split('00')
    f.close()
    return message_list
        
def start_level(level_file, level_msgs):
    # intiialise counter for ticks elapsed
    tick_counter = 0
    # initialise the pygame module
    pygame.init()
    # initialise the screen
    screen = pygame.display.set_mode(DISPLAY, FLAGS, DEPTH)
    # set the game caption
    pygame.display.set_caption("Jason Seagull vs Neil Catrick Harris")
    # initialise the game clock
    clock = pygame.time.Clock()

    # initialise the key states
    up_down = up_held = up_up = right_down = right_held = right_up =\
              down_down = down_held = down_up = left_down = left_held =\
              left_up = space_held = space_down = space_up = ctrl_down =\
              ctrl_up = ctrl_held = False
    # fill the screen
    screen.fill(bgcolour)
    # entities group holds all sprite entities
    entities = pygame.sprite.Group()
    # collidables group holds all things used in collision check
    collidables = pygame.sprite.Group()
    # blocks group holds all block types
    blocks = pygame.sprite.Group()
    # pitfalls group holds all pitfall blocks
    pitfalls = pygame.sprite.Group()
    # chip_buckets group holds all chip buckets
    chip_buckets = pygame.sprite.Group()
    gates = pygame.sprite.Group()
    buttons = pygame.sprite.Group()
    # initialise the player


    # variables used to draw the level
    x = y = 0
    # read the level file
    f = open(level_file)
    level = f.read()
    level_rows = level.split('\n')
    total_level_height = tile_size[1]*len(level_rows)
    # interpret the level file
    # note errors in  syntax will not be caught
    # correct syntax: lines with characters separated by commas,
    # with same amount of characters on each line

    button_exists = False
    for line in level_rows:
        row = line.split(',')
        total_level_width = tile_size[0]*len(row)
        for block in row:
            if block == "L":
                b = Lava(x, y)
                entities.add(b)
                collidables.add(b)
            if block == "G":
                g = Gate(x, y)
                gates.add(g)
                collidables.add(g)
            if block == "Bu":
                button = Button(x, y)
                entities.add(button)
                buttons.add(button)
                button_exists = True
            if block == "P":
                b = Pitfall(x, y)
                entities.add(b)
                collidables.add(b)
                pitfalls.add(b)
            if block == "S":
                player = Player(x, y)
                entities.add(player)
            if block == "B":
                b = Block(x, y)
                blocks.add(b)
                entities.add(b)
                collidables.add(b)
            # Added this to make Catrick. -A
            if block == "E":
                enemy = Enemy(x, y)
                entities.add(enemy)
                collidables.add(enemy)
            if block == "C":
                chips = Chips(x, y)
                entities.add(chips)
                collidables.add(chips)
                chip_buckets.add(chips)
            x += tile_size[0]
        y += tile_size[1]
        x = 0
    # intialise the camera
    camera = Camera(camera_function, total_level_width, total_level_height)
    f.close()
    backgrounds = []
    new_shit = Shit(0,0,False)
    for i in range(0,total_level_width,640):
        newback = Background(i,0)
        backgrounds.append(newback)
    running = True
    death = False
    bgpos = (0,0)

    for b in backgrounds:
            screen.blit(b.image, b.rect)
    for e in entities:
            # apply the offset to each entity
            # call this for everything that should scroll
            # which is basically everything other than GUI/HUD/UI
            if isinstance(e.image,pygame.Surface):
                screen.blit(e.image, e.rect)
            else:
                e.image.blit(screen,e.rect)
    
    display_messages(level_msgs, screen)
    while running:
        # limit the ticks/s to maxfps
        clock.tick(maxfps)
        # increment the tick counter
        tick_counter += 1
        # reset the instantaneous key states
        up_down = up_up = down_down = down_up = right_down = right_up =\
                  left_down  = left_up = space_down = space_up = ctrl_down =\
                  ctrl_up = False
        # set the key states based on the status of current events
        current_events = pygame.event.get()
        for e in current_events:
            if e.type == pygame.QUIT:
                game_close()
            if e.type == pygame.KEYDOWN and e.key == pygame.K_ESCAPE:
                game_close()
            if e.type == pygame.KEYDOWN and e.key == pygame.K_UP:
                up_down = up_held = True
            if e.type == pygame.KEYDOWN and e.key == pygame.K_DOWN:
                down_down = down_held = True
            if e.type == pygame.KEYDOWN and e.key == pygame.K_LEFT:
                left_down =  left_held = True
            if e.type == pygame.KEYDOWN and e.key == pygame.K_RIGHT:
                right_down = right_held = True
            if e.type == pygame.KEYDOWN and e.key == pygame.K_SPACE:
                space_down = space_held = True
            if e.type == pygame.KEYDOWN and e.key == pygame.K_LCTRL:
                ctrl_down = ctrl_held = True

            if e.type == pygame.KEYUP and e.key == pygame.K_UP:
                up_up = True
                up_held = False
            if e.type == pygame.KEYUP and e.key == pygame.K_DOWN:
                down_up = True
                down_held = False
            if e.type == pygame.KEYUP and e.key == pygame.K_LEFT:
                left_up =  True
                left_held = False
            if e.type == pygame.KEYUP and e.key == pygame.K_RIGHT:
                right_up = True
                right_held = False
            if e.type == pygame.KEYUP and e.key == pygame.K_SPACE:
                space_up = True
                space_held = False
            if e.type == pygame.KEYUP and e.key == pygame.K_LCTRL:
                ctrl_up = True
                ctrl_held = False

        for e in current_events:
            if e.type == pygame.KEYDOWN and e.key == pygame.K_BACKQUOTE:
                print key_states
            if e.type == pygame.KEYDOWN and e.key == pygame.K_r:
                start_level(level_file, level_msgs)
                return

        if death:
            start_level(level_file, level_msgs)
            return
        # put these states into a list
        key_states = [up_down, up_held, up_up, right_down, right_held,\
                      right_up, down_down, down_held, down_up, left_down,\
                      left_held, left_up, space_held, space_down, space_up,\
                      ctrl_down, ctrl_held, ctrl_up]

        
        # fill the screen
        screen.fill(bgcolour)

        # update the camera
        camera.update(player) # camera follows player

        # update the player
        player.update(key_states, collidables, new_shit)
        if not player.has_chips:
            for c in chip_buckets:
                c.set_alive(True, collidables)

        # Update the enemy. -A
        enemy.update(collidables, player)

        for b in backgrounds:
            screen.blit(b.image, camera.focus(b))

        ## DRAW EVERYTHING AFTER THE BACKGROUND LOL
        button_is_down = False
        if button_exists:
            for button in buttons:
                if button.stepped:
                    button_is_down = True
                button.update(player, enemy)
        if not button_is_down:
            for gate in gates:
                collidables.add(gate)
                screen.blit(gate.image, camera.focus(gate))
        else:
            for gate in gates:
                collidables.remove(gate)
        if new_shit.alive:
            if new_shit.update(collidables):
                return
            screen.blit(new_shit.image, camera.focus(new_shit))
        
        if player.dead:
            start_level(level_file, level_msgs)
            return
        for p in pitfalls:
            p.update(collidables)
        for e in entities:
            # apply the offset to each entity
            # call this for everything that should scroll
            # which is basically everything other than GUI/HUD/UI
            if isinstance(e.image,pygame.Surface):
                screen.blit(e.image, camera.focus(e))
            else:
                e.image.blit(screen,camera.focus(e))

        # load the display from the buffer
        pygame.display.flip()
    game_close()
    
def display_messages(msgs, screen):
    msg_background = pygame.image.load('assets/background/msg_background.png')
    
    message_font = pygame.font.Font('assets/fonts/arial.ttf',16)
    
    for message in msgs:
        screen.blit(msg_background, (125,200))
        msg_lines = message.split('\n')
        for i in range(len(msg_lines)):
            message_text = message_font.render(msg_lines[i],False,(255,255,255))
            screen.blit(message_text, (140,215+16*i))
        pygame.display.flip()
        
        key_pressed = False
        while key_pressed == False:
            current_events = pygame.event.get()
            for e in current_events:
                if e.type == pygame.KEYDOWN:
                    key_pressed = True
                elif e.type == pygame.QUIT:
                    game_close()
                elif e.type == pygame.MOUSEBUTTONDOWN:
                    print e.pos
            

def game_close():
    global running
    pygame.quit()
    sys.exit()
    running = False

def camera_function(camera, target_rect):
##    return camera
    l,t,_,_ = target_rect #l = left, t = top
    _,_,w,h = camera # w = width, h = height
    l,t,_,_ = -l+WIDTH/2, -t+HEIGHT/2, w, h

    l = min(0, l)
    l = max(WIDTH-camera.width,l)
    t = max(HEIGHT-camera.height,t)
    t = min(0, t)
    return pygame.Rect(l,t,w,h)

class Camera:
    # initialise the camera
    def __init__(self, camera_func, width, height):
        self.camera_func = camera_func
        self.state = pygame.Rect(0, 0, width, height)

    # apply the offset to an entity
    def focus(self, target):
        return target.rect.move(self.state.topleft)
##        return target.rect

    # update the position of the camera
    def update(self, target):
        self.state = self.camera_func(self.state, target.rect)
        ## pass
        
        

class Entity(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        
class Player(Entity):
    def __init__(self, x, y):
        Entity.__init__(self)
        # horizontal velocity
        self.xvel = 0
        # vertical velocity
        self.yvel = 0
        # state of the player
        # 0 = standing on ground, not moving
        # 1 = standing on ground, moving right
        # 2 = standing on ground, moving left
        # 3 = falling
        # 4 = flying
        self.state = 0
        # list of the images, won't be used when I get around to incorporating
        # animations
        self.images = ['assets/seagell/left1.png','assets/seagell/left2.png']
        self.imageObjs = []
        for i in self.images:
            self.imageObjs.append(pygame.image.load(i))
        # index of the current image
        self.current_image = 0
        # surface object for the current image
        self.image = self.imageObjs[self.current_image]
        # convert the image into correct pixel format
        # set the collision rectangle for the player
        self.rect = pygame.Rect(x, y, 57, 49)
        # Set the current jump count to zero.
        self.jump_count = 0
        self.has_chips = False
        self.dead = False

    def update(self, key_states, collidables, new_shit):
        if key_states[12]:
            self.current_image = 0
        else:
            self.current_image = 1
        self.image = self.imageObjs[self.current_image]
        if key_states[15]:
            # left ctrl pressed
            # take a shit
            if self.has_chips:
                new_shit.rect = pygame.Rect(self.rect.midbottom[0],\
                                            self.rect.midbottom[1],8,8)
                new_shit.alive = True
                self.has_chips = False
        if key_states[13]:
            # space button pressed
            # perhaps we should implement a limit on flaps before grounding
            # or something

            # Here's the jump limiting code. -A
            self.yvel = -14 + self.jump_count * 2
            if self.jump_count < 7:
                self.jump_count += 1
            
        if key_states[6]:
            # down button pressed
            # maybe make the seagull dive or something
            pass
        if key_states[10]:
            # left button is being held
            self.xvel = -5
        if key_states[4]:
            # right button is being held
            self.xvel = 5
        if self.state >= 3:
            # seagull is not on the ground
            # accelearate by gravity
            self.yvel += 1
            # I've changed the terminal velocity to 7 to make the player feel less heavy. -A
            if self.yvel > 7: self.yvel = 7
        if not(key_states[4] or key_states[10]):
            # neither right not left is held, reset horizontal speed
            self.xvel = 0
        # reset state, to be changed again if conditions apply
        self.state = 4
        # increment in x direction
        self.rect.left += self.xvel
        # do x-axis collisions
        self.hor_collide(self.xvel, collidables)
        # increment in y direction
        self.rect.top += self.yvel
        # do y-axis collisions
        self.vert_collide(self.yvel, collidables)

    def hor_collide(self, xvel, collidables):
        # test for horizontal collision and move player back if one is found
        for c in collidables:
            if pygame.sprite.collide_rect(self, c):
                if isinstance(c, Enemy):
                    self.dead = True
                if xvel > 0: self.rect.right = c.rect.left
                if xvel < 0: self.rect.left = c.rect.right

    def vert_collide(self, yvel, collidables):
        # test for vertical collision and move player back if one is found
        # also stop moving if ceiling or ground is hit
        for c in collidables:
            if pygame.sprite.collide_rect(self, c):
                if isinstance(c, Enemy) or isinstance(c, Lava):
                    self.dead = True
                if isinstance(c, Pitfall):
                    c.set_touched(True)
                if isinstance(c, Chips):
                    self.has_chips = True
                    chipget.play()
                    c.set_alive(False, collidables)
                if yvel > 0:
                    self.rect.bottom = c.rect.top
                    self.state = 0
                    self.yvel = 0
                    self.jump_count = 0
                if yvel < 0:
                    self.rect.top = c.rect.bottom
                    self.yvel = 0


class Block(Entity):
    def __init__(self, x, y):
        Entity.__init__(self)
        self.image = pygame.image.load('assets/block/block.png')
        self.rect = pygame.Rect(x,y,32,32)

    def update(self):
        # overwrite the default update function to do nothing
        pass

    
class Lava(Entity):
    def __init__(self, x, y):
        Entity.__init__(self)
        self.image = pygame.image.load('assets/block/lava.png')
        self.rect = pygame.Rect(x,y,32,32)

    def update(self):
        # overwrite the default update function to do nothing
        pass

    
class Shit(Entity):
    def __init__(self, x, y, alive):
        Entity.__init__(self)
        self.image = pygame.image.load('assets/crap/crap.png')
        self.rect = pygame.Rect(x,y,8,8)
        self.alive = alive
    def update(self, collidables):
        self.rect.top += 10
        for c in collidables:
            if pygame.sprite.collide_rect(self, c):
                self.alive = False
                if isinstance(c, Enemy):
                    return True
                return False
        


        
class Chips(Entity):
    def __init__(self, x, y):
        Entity.__init__(self)
        self.alive_image = pygame.image.load('assets/chips/chips.png')
        self.faded_image = pygame.image.load('assets/chips/chips_faded.png')
        self.image = self.alive_image
        self.rect = pygame.Rect(x,y,25,28)
        self.alive = True

    def set_alive(self, boolean, collidables):
        if boolean:
            self.image = self.alive_image
            collidables.add(self)
        else:
            self.image = self.faded_image
            collidables.remove(self)


class Gate(Entity):
    def __init__(self, x, y):
        Entity.__init__(self)
        self.image = pygame.image.load('assets/gate/gate.png')
        self.rect = pygame.Rect(x, y, 32, 32)
    
class Button(Entity):
    def __init__(self, x, y):
        Entity.__init__(self)
        self.stepped_image = pygame.image.load('assets/button/buttondown.png')
        self.not_stepped_image = pygame.image.load('assets/button/button.png')
        self.image = self.not_stepped_image
        self.stepped = False
        self.rect = pygame.Rect(x, y+23, 32,9)
    def update(self, player, enemy):
        if pygame.sprite.collide_rect(self, player) or \
           pygame.sprite.collide_rect(self, enemy):
            self.image = self.stepped_image
            self.stepped = True
        else :
            self.image = self.not_stepped_image
            self.stepped = False

class Background(pygame.sprite.Sprite):
    def __init__(self, x, y):
        pygame.sprite.Sprite.__init__(self)
        self.image = pygame.image.load('assets/background/background2.png')
        self.rect = pygame.Rect(x,y,640,640)
    def update(self):
        pass

class Pitfall(Entity):
    def __init__(self, x, y):
        Entity.__init__(self)
        self.alive_image = pygame.image.load('assets/block/block_pitfall.png')
        self.faded_image = pygame.image.load(\
            'assets/block/block_pitfall_faded.png')
        self.image = self.alive_image
        self.rect = pygame.Rect(x,y,32,32)
        self.timer = 0
        self.alive = True
        self.touched = False
    def update(self, collidables):
        if self.touched:
            self.timer += 1
        if (self.timer%360==359):
            collidables.add(self)
            self.image = self.alive_image
        if (self.timer%360==0):
            self.alive = True
            self.touched = False
        elif (self.timer%360)%60 == 0:
            self.image = self.faded_image
            self.alive = False
            collidables.remove(self)
        
    def set_touched(self, boolean):
        self.touched = boolean
            

# Enemy class for Neil Catrick. Essentially a modified copy of the Player class. -A
class Enemy(Entity):
    def __init__(self, x, y):
        Entity.__init__(self)
        # horizontal velocity
        self.xvel = 0
        # vertical velocity
        self.yvel = 0
        # state of the enemy
        # 0 = standing on ground, not moving
        # 1 = standing on ground, moving right
        # 2 = standing on ground, moving left
        # 3 = falling
        # 4 = flying
        self.state = 0
        # list of the images, won't be used when I get around to incorporating
        # animations
        self.right_standing = pygame.image.load('assets/catrick/catrick.png')
        self.left_standing = pygame.transform.flip(self.right_standing,\
                                                   True,False)
        self.animObjs = {}
        self.imagesAndDurations = [('assets/catrick/cat_walk_right.%s.png' %\
                               (str(num).rjust(3, '0')), 0.1) \
                              for num in range(3)]
        self.animObjs['walk_right'] = pyganim.PygAnimation(\
            self.imagesAndDurations)
        self.animObjs['walk_left'] = self.animObjs['walk_right'].getCopy()
        self.animObjs['walk_left'].flip(True, False)
        self.animObjs['walk_left'].makeTransformsPermanent()

        self.moveConductor = pyganim.PygConductor(self.animObjs)

        # set the collision rectangle for the player
        self.rect = pygame.Rect(x, y, player_size[0], player_size[1])

        self.direction = 'right'
        self.image = self.right_standing
        self.onGround = True

    def ai_logic(self, player):
        # Put AI stuff here.

        # Current psuedocode:
        # Make x equal to player's x.
        # y is always equal to the ground level.
        dx = player.rect.centerx-self.rect.centerx
        dy = player.rect.centery-self.rect.centery
        if not self.onGround:
            self.yvel += 1
            if self.yvel > 7: self.yvel = 7
        if player.rect.centerx - self.rect.centerx > 5:
            self.xvel = 1
            self.moveConductor.play()
            self.image = self.animObjs['walk_right']
            self.direction = 'right'
        elif self.rect.centerx - player.rect.centerx > 5:
            self.xvel = -1
            self.moveConductor.play()
            self.image = self.animObjs['walk_left']
            self.direction = 'left'
        else:
            self.xvel = 0
            self.moveConductor.stop()
            if self.direction == 'right':
                self.image = self.right_standing
            else:
                self.image = self.left_standing
##        if math.hypot(dx, dy) < 200:
##            if self.onGround:
##                self.yvel = 14*dy/(math.fabs(dy)+math.fabs(dx))
##                self.xvel = 14*dx/(math.fabs(dy)+math.fabs(dx))
    def update(self, collidables, player):
        self.ai_logic(player)
        # increment in x direction
        self.onGround = False
        self.rect.left += self.xvel
        # do x-axis collisions
        self.hor_collide(self.xvel, collidables)
        # increment in y direction
        self.rect.top += self.yvel
        # do y-axis collisions
        self.vert_collide(self.yvel, collidables)

        
    def hor_collide(self, xvel, collidables):
        # test for horizontal collision and move player back if one is found
        for c in collidables:
            if pygame.sprite.collide_rect(self, c):
                if isinstance(c, Enemy):
                    pass
                else:
		    if xvel > 0: self.rect.right = c.rect.left
                    if xvel < 0: self.rect.left = c.rect.right

    def vert_collide(self, yvel, collidables):
        # test for vertical collision and move player back if one is found
        # also stop moving if ceiling or ground is hit
        for c in collidables:
            if not isinstance(c, Enemy) and \
               pygame.sprite.collide_rect(self, c):
                if yvel > 0:
                    self.onGround = True
                    self.rect.bottom = c.rect.top
                    self.state = 0
                    self.yvel = 0
                if yvel < 0:
                    self.rect.top = c.rect.bottom
                    self.yvel = 0
    

if(__name__ == "__main__"):
    main()

